<template>
  <div class="mt-menu">
    <div class="is-flex" @click="toggle">
      <div class="has-text-weight-bold is-size-7 is-hidden-mobile">MENU</div>
      <b-icon icon="menu" />
    </div>
    <transition name="fade">
      <div v-show="isOpen" class="overlay">
        <div class="overlay-background" @click="toggle"></div>
        <aside>
          <div class="header columns">
            <div class="has-text-weight-bold"></div>
            <div class="cursor-as-pointer" @click="toggle">
              <b-icon icon="close" />
            </div>
          </div>
          <div class="mt-utilisateur-mobile is-hidden-tablet">
            <div>
              <div class="is-size-7"><mt-utilisateur :utilisateur="utilisateur" /></div>
              <b-field>
                <b-select size="is-small" :value="profil" placeholder="Choisir un profil" expanded @input="setProfil">
                  <option
                    v-for="userProfil in utilisateur.userProfils"
                    :key="userProfil.profil.id"
                    :value="userProfil.profil.code"
                  >
                    {{ userProfil.profil.description }}
                  </option>
                </b-select>
              </b-field>
            </div>
          </div>
          <div>
            <ul class=" has-text-weight-bold is-size-8 menu-niveau-1">
              <li v-if="isEmployeur || isAdminLocal">
                <div class="is-uppercase"><b-icon icon="clipboard-text"></b-icon>Activités</div>
                <ul class="has-text-weight-normal is-size-7 ">
                  <li>
                    <nuxt-link :to="profilLink({ name: 'index' })" @click.native="toggle"
                      >Planning des activités
                    </nuxt-link>
                  </li>
                  <li>
                    <nuxt-link :to="profilLink({ name: 'activites' })" @click.native="toggle"
                      >Liste des activités
                    </nuxt-link>
                  </li>
                  <li v-if="isEmployeur">
                    <nuxt-link :to="profilLink({ name: 'activites-creer' })" @click.native="toggle"
                      >Créer une activité
                    </nuxt-link>
                  </li>
                </ul>
              </li>
              <li v-else>
                <nuxt-link :to="profilLink({ name: 'index' })" @click.native="toggle">
                  <div class="is-uppercase"><b-icon icon="calendar"></b-icon>Calendrier des disponibilites</div>
                </nuxt-link>
              </li>
              <li v-if="isEmployeur">
                <nuxt-link :to="profilLink({ name: 'disponibilites-unite' })" @click.native="toggle">
                  <div class="is-uppercase"><b-icon icon="account-multiple"></b-icon>Disponibilités de mon unité</div>
                </nuxt-link>
              </li>
              <li v-if="isEmployeur || isAdminLocal || isSuperEmploye">
                <mt-sous-menu titre="Pax de l'unité" icon="account-multiple">
                  <ul class="has-text-weight-normal is-size-7 ">
                    <li>
                      <nuxt-link :to="profilLink({ name: 'pax' })" @click.native="toggle"
                        >Liste des pax de mon unité
                      </nuxt-link>
                    </li>
                    <li v-if="isEmployeur || isAdminLocal">
                      <nuxt-link :to="profilLink({ name: 'invitation' })" @click.native="toggle"
                        >Gérer mes invitations
                      </nuxt-link>
                    </li>
                    <li v-if="isEmployeur || isSuperEmploye">
                      <nuxt-link :to="profilLink({ name: 'pax-groupe' })" @click.native="toggle"
                        >Gérer mes groupes
                      </nuxt-link>
                    </li>
                  </ul>
                </mt-sous-menu>
              </li>
              <li v-if="isEmploye && !isSuperEmploye">
                <nuxt-link :to="profilLink({ name: 'pax' })" @click.native="toggle">
                  <div class="is-uppercase"><b-icon icon="account-multiple"></b-icon>Pax de l’unité</div>
                </nuxt-link>
              </li>
              <li>
                <nuxt-link :to="{ name: 'infos-persos' }" @click.native="toggle">
                  <div class="is-uppercase"><b-icon icon="account"></b-icon>Mon Compte</div>
                </nuxt-link>
              </li>
              <!--               Todo uncomment apres gestion de crise-->
              <!--              <li>-->
              <!--                <nuxt-link :to="{ name: 'index' }">-->
              <!--                  <div class="is-uppercase"><b-icon icon="settings"></b-icon>Paramètres</div>-->
              <!--                </nuxt-link>-->
              <!--              </li>-->
              <li v-if="isAdminLocal">
                <mt-sous-menu titre="Dashboard" icon="apps">
                  <ul class="has-text-weight-normal is-size-7">
                    <li v-if="isAdmin">
                      <nuxt-link :to="profilLink({ name: 'dashboard-sondage' })" @click.native="toggle"
                        >Sondage</nuxt-link
                      >
                    </li>
                    <li v-if="isAdmin">
                      <nuxt-link :to="profilLink({ name: 'dashboard-statistiques' })" @click.native="toggle"
                        >Statistiques</nuxt-link
                      >
                    </li>
                    <li>
                      <nuxt-link :to="profilLink({ name: 'dashboard-utilisateurs' })" @click.native="toggle"
                        >Utilisateurs
                      </nuxt-link>
                    </li>
                    <li v-if="isAdmin">
                      <nuxt-link :to="profilLink({ name: 'dashboard-profils' })" @click.native="toggle"
                        >Profils</nuxt-link
                      >
                    </li>
                    <li>
                      <nuxt-link :to="profilLink({ name: 'dashboard-activites' })" @click.native="toggle"
                        >Activités
                      </nuxt-link>
                    </li>
                    <li v-if="isAdmin">
                      <nuxt-link :to="profilLink({ name: 'dashboard-etape' })" @click.native="toggle"
                        >Etapes
                      </nuxt-link>
                    </li>
                    <li v-if="isAdmin">
                      <nuxt-link :to="profilLink({ name: 'dashboard-types-activites' })" @click.native="toggle"
                        >Types d'activités</nuxt-link
                      >
                    </li>
                    <li v-if="isAdmin">
                      <nuxt-link :to="profilLink({ name: 'dashboard-postesro' })" @click.native="toggle"
                        >Postes RO
                      </nuxt-link>
                    </li>
                    <li>
                      <nuxt-link :to="profilLink({ name: 'dashboard-organismes' })" @click.native="toggle"
                        >Organismes
                      </nuxt-link>
                    </li>
                    <li v-if="isAdmin">
                      <nuxt-link :to="profilLink({ name: 'dashboard-typedisponibilite' })" @click.native="toggle"
                        >Types disponibilités
                      </nuxt-link>
                    </li>
                    <li v-if="isAdmin">
                      <nuxt-link :to="profilLink({ name: 'dashboard-types-organismes' })" @click.native="toggle"
                        >Types d'organismes</nuxt-link
                      >
                    </li>
                    <li v-if="isAdmin">
                      <nuxt-link :to="profilLink({ name: 'dashboard-corps' })" @click.native="toggle"
                        >Catégories</nuxt-link
                      >
                    </li>
                    <li v-if="isAdmin">
                      <nuxt-link :to="profilLink({ name: 'dashboard-grades' })" @click.native="toggle"
                        >Grades</nuxt-link
                      >
                    </li>
                    <li v-if="isAdmin">
                      <nuxt-link :to="profilLink({ name: 'dashboard-droit-creation-profil' })" @click.native="toggle"
                        >Droit création profil</nuxt-link
                      >
                    </li>
                    <li v-if="isAdmin">
                      <nuxt-link :to="profilLink({ name: 'dashboard-contacter' })" @click.native="toggle"
                        >Messages</nuxt-link
                      >
                    </li>
                    <li v-if="isAdmin">
                      <nuxt-link :to="profilLink({ name: 'dashboard-evaluation' })" @click.native="toggle"
                        >Évaluations</nuxt-link
                      >
                    </li>
                  </ul>
                </mt-sous-menu>
              </li>
              <li class="cursor-as-pointer" @click="logout">
                <div class="is-uppercase">Déconnexion</div>
              </li>
            </ul>
          </div>
        </aside>
      </div>
    </transition>
  </div>
</template>

<script>
import MtSousMenu from './sous-menu';
import userMixin from '~/components/mixins/userMixin';
import MtUtilisateur from '~/components/pax/mt-utilisateur';

export default {
  components: {
    MtUtilisateur,
    MtSousMenu,
  },
  mixins: [userMixin],
  data() {
    return {
      isOpen: false,
    };
  },
  methods: {
    toggle() {
      this.isOpen = !this.isOpen;
    },
    setProfil(profil) {
      this.$store.dispatch('context/setProfil', profil);
      this.$router.push({
        name: 'profil',
        params: { profil },
      });
      this.toggle();
    },
    logout() {
      try {
        this.$auth.logout();
      } finally {
        this.$buefy.toast.open({ message: 'À bientôt !', type: 'is-success' });
        this.$router.push('/connexion');
      }
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';

.mt-menu {
  .is-flex {
    align-items: center;
  }
}

.overlay {
  cursor: auto;
  display: flex;
  z-index: 10;
  position: fixed;
  left: 0;
  right: 0;
  top: 0;
  bottom: 0;

  .overlay-background {
    background-color: rgba(255, 255, 255, 0.55);
    flex-grow: 1;
    cursor: pointer;
    backdrop-filter: blur(5px);
  }

  aside {
    padding: 2rem 0;
    box-shadow: -2px 0 6px -2px rgba(164, 164, 164, 0.5);
    min-height: 100%;
    overflow-y: auto;
    background-color: $white;
    width: 400px;
    z-index: 12;
    cursor: default;

    .menu-niveau-1 > li {
      margin-bottom: 1rem;
    }
  }

  .header {
    display: flex;
    justify-content: flex-end;
    margin: 0 2rem;

    div {
      padding: 0.5rem 0.75rem;
    }

    div:last-child {
      padding-right: 0;
    }
  }

  .mt-utilisateur-mobile {
    display: flex;
    flex-direction: row;
    padding: 0.3rem 0.3rem 0.3rem 3rem;
    align-items: center;
    margin-bottom: 1rem;
  }

  ul {
    li {
      display: flex;
      flex-direction: column;
    }
    & div {
      display: flex;
      flex-direction: row;
      padding: 0.3rem 0.3rem 0.3rem 3rem;
      align-items: center;

      & + ul {
        margin-top: 0.3rem;
      }

      .icon {
        padding-right: 0.8em;
        font-size: 1em;
        margin: 0;
      }
    }
    li li a {
      padding: 0.3rem 0.3rem 0.3rem 3rem;
      transition-property: background-color, color;
      transition-duration: 0.3s;
      position: relative;

      &.nuxt-link-exact-active,
      &:hover {
        background-color: $pale-grey-three;
        color: #8ba6ff;
      }

      &:active::before,
      &.nuxt-link-exact-active::before {
        border-right-color: $periwinkle-blue;
      }

      &::before {
        content: '';
        width: 0;
        border-right: 4px solid transparent;
        border-radius: 0 4px 4px 0;
        position: absolute;
        top: 0;
        bottom: 0;
        left: 0;
        transition-property: border-right-color;
        transition-duration: 0.3s;
      }
    }
  }
}
.fade-enter-active {
  animation: fade-in 300ms;
}
.fade-leave-active {
  animation-delay: 100ms;
  animation: fade-in 300ms reverse;
}
@keyframes fade-in {
  0% {
    opacity: 0;
  }
  100% {
    opacity: 1;
  }
}
</style>
